image: docker:19.03.12

variables:
  DOCKER_TLS_CERTDIR: "/certs"

services:
  - docker:19.03.12-dind

stages:
  - build

build_staging_generators:
  stage: build

  only:
    - master    
  
  variables:
    DEPLOY_ENV: staging

  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login registry.gitlab.com --username "starlight-ops" --password-stdin

  script:
    - docker build --build-arg DEPLOY_ENV=${DEPLOY_ENV} -t le7el-generators:latest .
    - docker tag le7el-generators:latest registry.gitlab.com/le7el/build/generators:latest
    - docker push registry.gitlab.com/le7el/build/generators:latest
    - docker system prune --force

build_prod_generators:
  stage: build

  only:
    - /^v[0-9\.]*$/i

  except:
    - branches
  
  variables:
    DEPLOY_ENV: prod

  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login registry.gitlab.com --username "starlight-ops" --password-stdin

  script:
    - docker build --build-arg DEPLOY_ENV=${DEPLOY_ENV} -t le7el-generators:${CI_COMMIT_TAG} .
    - docker tag le7el-generators:${CI_COMMIT_TAG} registry.gitlab.com/le7el/build/generators:${CI_COMMIT_TAG}
    - docker push registry.gitlab.com/le7el/build/generators:${CI_COMMIT_TAG}
    - docker system prune --force
